<template>
  <div class="gpa-library__content">
    <rui-panel class="gpa-library__list-panel" resize="right">
      <rui-search-form v-model="searchTerm" />
      <div class="_virtual-scroll-area">
        <rui-list-item v-for="group in resourceInteractionsGroups"
                       :key="group.id"
                       :caption="group.name"
                       :active="selectedGroupId === group.id"
                       :to="{name: 'resourceInteractionsGroups', params: {resourceInteractionsGroupId: group.id }}" />
      </div>
    </rui-panel>

    <div class="gpa-library__content__resource">
      <rui-alert v-if="!selectedGroup" variant="mute">{{ $t('js.resourceInteractionsGroups.index.no_selected_group') }}</rui-alert>
      <div v-else>
        <gpa-resource-interactions-group-item :resource-interactions-group="selectedGroup" />
      </div>
    </div>
  </div>
</template>

<script>
import RuiAlert from '@experiments-labs/rise_ui/src/components/Alert/Alert.vue'
import RuiSearchForm from '@experiments-labs/rise_ui/src/components/Form/SearchForm.vue'
import RuiListItem from '@experiments-labs/rise_ui/src/components/ListItem/ListItem.vue'
import RuiPanel from '@experiments-labs/rise_ui/src/components/Panel/Panel.vue'

import GpaResourceInteractionsGroupItem from './ResourceInteractionsGroup/_Item.vue'

export default {
  name: 'GpaResourceInteractionsGroups',
  components: { RuiAlert, RuiListItem, RuiSearchForm, RuiPanel, GpaResourceInteractionsGroupItem },
  data () {
    return {
      selectedGroupId: null,
      searchTerm: '',
    }
  },
  computed: {
    resourceInteractionsGroups () {
      return this.$store.getters.resourceInteractionsGroups
        .filter(g => g.name.toLowerCase().includes(this.searchTerm.toLowerCase()))
    },
    selectedGroup () {
      return this.$store.getters.resourceInteractionsGroup(this.selectedGroupId)
    },
  },
  methods: {
    setSelectedGroupId () {
      const id = this.$route.params.resourceInteractionsGroupId
      this.selectedGroupId = id ? parseInt(id, 10) : null
    },
  },
  mounted () {
    this.setSelectedGroupId()
  },
  watch: {
    $route () {
      this.setSelectedGroupId()
    },
  },
}
</script>
